package FilterImages;

use base qw( HTTP::Proxy::BodyFilter );
use DecolorImages qw(decolor_most_images);

# TODO: change content-length header to new content-length
# (or is this done by the proxy automatically?)


my $persistentref;
my $imagetype;

sub filter {
   my ( $self, $dataref, $message, $protocol, $buffer ) = @_;

   $persistentref = $dataref;
   $imagetype = get_image_type($message);
}

# call decolor when image is complete
sub end {
   decolor_most_images( $persistentref, $imagetype );
}


sub get_image_type {
  my $message = shift;
  my $headers = $message->headers();
  
  my $content_type = $headers->header("Content-type");

  $content_type =~ s/image\///;

  return $content_type;
}

1;
__END__
