#!/usr/bin/perl -w

use strict;
use HTTP::Proxy qw( :log );;
use HTTP::Proxy::BodyFilter::complete;
use HTTP::Proxy::BodyFilter::simple;
use FilterHTML;
use FilterImages;

# 
# small proxy which converts web pages (including images) into b+w
#
# Author:  Robert Jäschke
# Version: 0.0.3
# Changes:
#   2009-03-05
#   - added comments and release header
#
# TODO:
# fix HTML filter to work on complete HTML pages 
# (with sub end {})

# initialisation
my $proxy = HTTP::Proxy->new;
# listen on port 3333
$proxy->port( 3333 );
# accept connections from all hosts
$proxy->host( "" ); 
# log level
$proxy->logmask ( STATUS | PROCESS );

# HTML
$proxy->push_filter( 
  mime => "text/html", 
  response => HTTP::Proxy::BodyFilter::complete->new(), 
  response => FilterHTML->new() 
);

# CSS
$proxy->push_filter( 
  mime => "text/css", 
  response => HTTP::Proxy::BodyFilter::complete->new(), 
  response => FilterHTML->new() 
);

# IMAGES
$proxy->push_filter( 
  mime => "image/*", 
  response => HTTP::Proxy::BodyFilter::complete->new(), 
  response => FilterImages->new() 
);

#$proxy->push_filter( mime => "*/*", response => FilterHTML->new() );

# this is a MainLoop-like method
$proxy->start;

